/* sf52r.f -- translated by f2c (version 20000817).
   You must link the resulting object file with the libraries:
        -lf2c -lm   (in that order)
*/

#include "f2c.h"

/* Table of constant values */

static integer c__52 = 52;

real sf52r_c(real *x, real *y, real *rho, integer *ierr)
{
    /* Initialized data */

    static real sys093 = .999999f;
    static real sys059 = 3.4e38f;
    static real sys089 = 1e-6f;

    /* System generated locals */
    real ret_val, r__1;

    /* Builtin functions */
    double sqrt(doublereal);

    /* Local variables */
    extern real sf53r_c(real *, real *, real *), sf49r_c(real *);
    static real c0;
    extern /* Subroutine */ int utsf14_c(integer *, integer *);
    static real f1, ax, ay, qx, qy, tx, ty, xy;
    static integer ind, iax, iay;

    c0 = (real)sqrt(.5f);
    *ierr = 0;
    if (abs(*rho) < sys093) {
        goto L1;
    }
    *ierr = 65;
    ret_val = sys059;
    goto L10;
L1:
    f1 = 1.f / (real)sqrt((real)(1.f - *rho * *rho));
    xy = *x * *y;
    iax = 0;
    iay = 0;
    ind = 0;
    if (xy == 0.f) {
        goto L2;
    }
    ax = f1 * (*y / *x - *rho);
    ay = f1 * (*x / *y - *rho);
    goto L5;
L2:
    if (*x != 0.f) {
        goto L3;
    }
    if (*y != 0.f) {
        goto L4;
    }
    ax = f1 * (1.f - *rho);
    ay = ax;
    goto L5;
L3:
    ty = .25f;
    if (*x < 0.f) {
        ty = -ty;
    }
    ax = -f1 * *rho;
    ind = 1;
    goto L5;
L4:
    tx = .25f;
    if (*y < 0.f) {
        tx = -tx;
    }
    ay = -f1 * *rho;
    goto L7;
L5:
    if (ax >= 0.f) {
        goto L6;
    }
    iax = 1;
    ax = -ax;
L6:
    tx = (real)sf53r_c(x, &ax, &sys089);
    if (iax != 0) {
        tx = -tx;
    }
    if (ind != 0) {
        goto L9;
    }
L7:
    if (ay >= 0.f) {
        goto L8;
    }
    iay = 1;
    ay = -ay;
L8:
    ty = (real)sf53r_c(y, &ay, &sys089);
    if (iay != 0) {
        ty = -ty;
    }
L9:
    qx = (real)sf49r_c(x);
    qy = (real)sf49r_c(y);
    ret_val = (qx + qy) * .5f - tx - ty;
    if (xy <= 0.f && (xy != 0.f || *x + *y < 0.f)) {
        ret_val += -.5f;
    }
/* Computing MIN */
    r__1 = max(0.f,ret_val);
    ret_val = min(r__1,1.f);
L10:
    if (*ierr != 0) {
        utsf14_c(ierr, &c__52);
    }
    return ret_val;
} /* sf52r_c */
